'use strict';

exports.__esModule = true;

var _ReferencePropertyAction = require('./ReferencePropertyAction');

var _ReferencePropertyAction2 = _interopRequireDefault(_ReferencePropertyAction);

var _PropertyDescriptorAction = require('./PropertyDescriptorAction');

var _PropertyDescriptorAction2 = _interopRequireDefault(_PropertyDescriptorAction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2017 Moshe Simantov
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the Apache License, Version 2.0 (the "License");
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * you may not use this file except in compliance with the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * You may obtain a copy of the License at
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *     http://www.apache.org/licenses/LICENSE-2.0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Unless required by applicable law or agreed to in writing, software
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * distributed under the License is distributed on an "AS IS" BASIS,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * See the License for the specific language governing permissions and
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * limitations under the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var LocalDefinePropertyAction = function (_ReferencePropertyAct) {
  _inherits(LocalDefinePropertyAction, _ReferencePropertyAct);

  LocalDefinePropertyAction.fromRemote = function fromRemote(session, reference, property, descriptor) {
    return new this(reference, session.dispatch(property), _PropertyDescriptorAction2.default.fromPropertyDescriptor(session, descriptor));
  };

  function LocalDefinePropertyAction(reference, property, descriptor) {
    _classCallCheck(this, LocalDefinePropertyAction);

    if (!(descriptor instanceof _PropertyDescriptorAction2.default)) {
      throw new TypeError('Expect descriptor to be instance of PropertyDescriptorAction: ' + descriptor);
    }

    var _this = _possibleConstructorReturn(this, _ReferencePropertyAct.call(this, reference, property));

    _this.descriptor = descriptor;
    return _this;
  }

  LocalDefinePropertyAction.prototype.fetch = function fetch(session) {
    var target = session.get(this.reference);

    if (!session.isWritable(target)) {
      throw new TypeError('Can\'t define property of a read-only object: ' + target);
    }

    var property = this.constructor.fetch(session, this.property);
    var descriptor = this.constructor.fetch(session, this.descriptor);

    return Reflect.defineProperty(target, property, descriptor);
  };

  LocalDefinePropertyAction.prototype.exec = function exec(session) {
    this.fetch(session);
  };

  LocalDefinePropertyAction.prototype.toArgumentsList = function toArgumentsList() {
    return [this.reference, this.property, this.descriptor];
  };

  return LocalDefinePropertyAction;
}(_ReferencePropertyAction2.default);

exports.default = LocalDefinePropertyAction;