'use strict';

exports.__esModule = true;

var _ReferencePropertyAction = require('./ReferencePropertyAction');

var _ReferencePropertyAction2 = _interopRequireDefault(_ReferencePropertyAction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2017 Moshe Simantov
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the Apache License, Version 2.0 (the "License");
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * you may not use this file except in compliance with the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * You may obtain a copy of the License at
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *     http://www.apache.org/licenses/LICENSE-2.0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Unless required by applicable law or agreed to in writing, software
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * distributed under the License is distributed on an "AS IS" BASIS,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * See the License for the specific language governing permissions and
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * limitations under the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var LocalDeletePropertyAction = function (_ReferencePropertyAct) {
  _inherits(LocalDeletePropertyAction, _ReferencePropertyAct);

  function LocalDeletePropertyAction() {
    _classCallCheck(this, LocalDeletePropertyAction);

    return _possibleConstructorReturn(this, _ReferencePropertyAct.apply(this, arguments));
  }

  LocalDeletePropertyAction.fromRemote = function fromRemote(session, reference, property) {
    return this.fromProperty(session, reference, property);
  };

  LocalDeletePropertyAction.prototype.fetch = function fetch(session) {
    var target = session.get(this.reference);

    if (!session.isWritable(target)) {
      throw new TypeError('Can\'t delete property of a read-only object: ' + target);
    }

    var property = this.constructor.fetch(session, this.property);

    return Reflect.deleteProperty(target, property);
  };

  LocalDeletePropertyAction.prototype.exec = function exec(session) {
    this.fetch(session);
  };

  return LocalDeletePropertyAction;
}(_ReferencePropertyAction2.default);

exports.default = LocalDeletePropertyAction;