'use strict';

exports.__esModule = true;

var _remoteInstance = require('remote-instance');

var _ReferenceAction2 = require('./ReferenceAction');

var _ReferenceAction3 = _interopRequireDefault(_ReferenceAction2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2017 Moshe Simantov
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the Apache License, Version 2.0 (the "License");
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * you may not use this file except in compliance with the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * You may obtain a copy of the License at
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *     http://www.apache.org/licenses/LICENSE-2.0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Unless required by applicable law or agreed to in writing, software
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * distributed under the License is distributed on an "AS IS" BASIS,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * See the License for the specific language governing permissions and
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * limitations under the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var LocalSetPrototypeOfAction = function (_ReferenceAction) {
  _inherits(LocalSetPrototypeOfAction, _ReferenceAction);

  LocalSetPrototypeOfAction.fromRemote = function fromRemote(session, reference, prototype) {
    return new this(reference, session.dispatch(prototype));
  };

  function LocalSetPrototypeOfAction(reference) {
    var prototype = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

    _classCallCheck(this, LocalSetPrototypeOfAction);

    if (prototype !== null && !(prototype instanceof _ReferenceAction3.default)) {
      throw new TypeError('Invalid prototype: ' + prototype);
    }

    var _this = _possibleConstructorReturn(this, _ReferenceAction.call(this, reference));

    _this.prototype = prototype;
    return _this;
  }

  LocalSetPrototypeOfAction.prototype.fetch = function fetch(session) {
    var target = session.get(this.reference);

    if (!session.isWritable(target)) {
      throw new TypeError('Can\'t set prototype of a read-only object: ' + target);
    }

    var prototype = this.constructor.fetch(session, this.prototype);

    return Reflect.setPrototypeOf(target, prototype);
  };

  LocalSetPrototypeOfAction.prototype.exec = function exec(session) {
    this.fetch(session);
  };

  LocalSetPrototypeOfAction.prototype.toArgumentsList = function toArgumentsList() {
    var argumentsList = [this.reference, this.prototype];
    var defaults = [undefined, null];

    return (0, _remoteInstance.trimArgumentsList)(argumentsList, defaults);
  };

  return LocalSetPrototypeOfAction;
}(_ReferenceAction3.default);

exports.default = LocalSetPrototypeOfAction;