'use strict';

exports.__esModule = true;

var _remoteProtocol = require('remote-protocol');

var _remoteInstance = require('remote-instance');

var _UndefinedValueAction = require('./UndefinedValueAction');

var _UndefinedValueAction2 = _interopRequireDefault(_UndefinedValueAction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2017 Moshe Simantov
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the Apache License, Version 2.0 (the "License");
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * you may not use this file except in compliance with the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * You may obtain a copy of the License at
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *     http://www.apache.org/licenses/LICENSE-2.0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Unless required by applicable law or agreed to in writing, software
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * distributed under the License is distributed on an "AS IS" BASIS,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * See the License for the specific language governing permissions and
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * limitations under the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

/**
 * @extends {Action}
 */
var PropertyDescriptorAction = function (_Action) {
  _inherits(PropertyDescriptorAction, _Action);

  PropertyDescriptorAction.fromProperty = function fromProperty(session, obj, prop) {
    var descriptor = Object.getOwnPropertyDescriptor(obj, prop);

    return this.fromPropertyDescriptor(session, descriptor);
  };

  PropertyDescriptorAction.fromPropertyDescriptor = function fromPropertyDescriptor(session, descriptor) {
    return new this(session.dispatch(descriptor.value), descriptor.configurable === true, descriptor.writable === true, descriptor.enumerable === true, descriptor.get ? session.dispatch(descriptor.get) : null, descriptor.set ? session.dispatch(descriptor.set) : null);
  };

  function PropertyDescriptorAction() {
    var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;
    var configurable = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var writable = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
    var enumerable = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
    var get = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
    var set = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : null;

    _classCallCheck(this, PropertyDescriptorAction);

    if (typeof configurable !== 'boolean') {
      throw new TypeError('Argument "configurable" must be a boolean');
    }
    if (typeof writable !== 'boolean') {
      throw new TypeError('Argument "writable" must be a boolean');
    }
    if (typeof enumerable !== 'boolean') {
      throw new TypeError('Argument "enumerable" must be a boolean');
    }
    if (!_UndefinedValueAction2.default.isUndefined(value) || writable) {
      if (get !== null || set !== null) {
        throw new TypeError('Invalid property descriptor. ' + 'Cannot both specify accessors and a value or writable attribute');
      }
    }

    var _this = _possibleConstructorReturn(this, _Action.call(this));

    _this.value = value;
    _this.configurable = configurable;
    _this.writable = writable;
    _this.enumerable = enumerable;
    _this.get = get;
    _this.set = set;
    return _this;
  }

  PropertyDescriptorAction.prototype.fetch = function fetch(session) {
    if (this.get === null && this.set === null) {
      var value = this.constructor.fetch(session, this.value);

      return {
        value: value,
        configurable: this.configurable,
        writable: this.writable,
        enumerable: this.enumerable
      };
    }

    var get = this.constructor.fetch(session, this.get) || undefined;
    var set = this.constructor.fetch(session, this.set) || undefined;

    if (get !== undefined && typeof get !== 'function') {
      throw new TypeError('Argument "get" must be a function or null');
    }
    if (set !== undefined && typeof set !== 'function') {
      throw new TypeError('Argument "set" must be a function or null');
    }

    return {
      configurable: this.configurable,
      enumerable: this.enumerable,
      get: get,
      set: set
    };
  };

  PropertyDescriptorAction.prototype.toArgumentsList = function toArgumentsList() {
    var argumentsList = [this.value, this.configurable, this.writable, this.enumerable, this.get, this.set];
    var defaults = [undefined, true, true, true, null, null];

    return (0, _remoteInstance.trimArgumentsList)(argumentsList, defaults);
  };

  return PropertyDescriptorAction;
}(_remoteProtocol.Action);

exports.default = PropertyDescriptorAction;