'use strict';

exports.__esModule = true;

var _remoteProtocol = require('remote-protocol');

var _PropertyDescriptorAction = require('./PropertyDescriptorAction');

var _PropertyDescriptorAction2 = _interopRequireDefault(_PropertyDescriptorAction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2017 Moshe Simantov
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the Apache License, Version 2.0 (the "License");
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * you may not use this file except in compliance with the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * You may obtain a copy of the License at
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *     http://www.apache.org/licenses/LICENSE-2.0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Unless required by applicable law or agreed to in writing, software
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * distributed under the License is distributed on an "AS IS" BASIS,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * See the License for the specific language governing permissions and
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * limitations under the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

/**
 * @extends {Action}
 */
var PropertyDescriptorsAction = function (_Action) {
  _inherits(PropertyDescriptorsAction, _Action);

  PropertyDescriptorsAction.fromObject = function fromObject(session, obj) {
    var descriptors = Object.getOwnPropertyDescriptors(obj);

    if (obj instanceof Error) {
      if (!session.showStack) {
        delete descriptors.stack;
      }
    }

    return this.fromPropertyDescriptors(session, descriptors);
  };

  PropertyDescriptorsAction.fromPropertyDescriptors = function fromPropertyDescriptors(session, descriptors) {
    return new this(Object.keys(descriptors).reduce(function (arr, property) {
      arr.push(property, _PropertyDescriptorAction2.default.fromPropertyDescriptor(session, descriptors[property]));
      return arr;
    }, []));
  };

  function PropertyDescriptorsAction() {
    var descriptors = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    _classCallCheck(this, PropertyDescriptorsAction);

    if (!Array.isArray(descriptors) || descriptors.length % 2 !== 0) {
      throw new TypeError('Invalid descriptors array: ' + descriptors);
    }

    var _this = _possibleConstructorReturn(this, _Action.call(this));

    _this.descriptors = descriptors;
    return _this;
  }

  PropertyDescriptorsAction.prototype.isEmpty = function isEmpty() {
    return !this.descriptors.length;
  };

  PropertyDescriptorsAction.prototype.fetch = function fetch(session) {
    var descriptors = {};

    for (var i = 0; i < this.descriptors.length; i += 2) {
      var property = this.constructor.fetch(session, this.descriptors[i]);

      descriptors[property] = this.constructor.fetch(session, this.descriptors[i + 1]);
    }

    return descriptors;
  };

  PropertyDescriptorsAction.prototype.toArgumentsList = function toArgumentsList() {
    if (!this.descriptors.length) return [];

    return [this.descriptors];
  };

  return PropertyDescriptorsAction;
}(_remoteProtocol.Action);

exports.default = PropertyDescriptorsAction;