'use strict';

exports.__esModule = true;

var _remoteInstance = require('remote-instance');

var _ReflectAction2 = require('./ReflectAction');

var _ReflectAction3 = _interopRequireDefault(_ReflectAction2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2017 Moshe Simantov
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the Apache License, Version 2.0 (the "License");
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * you may not use this file except in compliance with the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * You may obtain a copy of the License at
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *     http://www.apache.org/licenses/LICENSE-2.0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Unless required by applicable law or agreed to in writing, software
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * distributed under the License is distributed on an "AS IS" BASIS,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * See the License for the specific language governing permissions and
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * limitations under the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var ReflectConstructAction = function (_ReflectAction) {
  _inherits(ReflectConstructAction, _ReflectAction);

  ReflectConstructAction.fromProxy = function fromProxy(session, target, argumentsList) {
    return new this(target, argumentsList.map(function (arg) {
      return session.dispatch(arg);
    }));
  };

  function ReflectConstructAction(target) {
    var argumentsList = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

    _classCallCheck(this, ReflectConstructAction);

    if (!Array.isArray(argumentsList)) {
      throw new TypeError('Expect argumentsList to be an Array: ' + argumentsList);
    }

    var _this = _possibleConstructorReturn(this, _ReflectAction.call(this, target));

    _this.argumentsList = argumentsList;
    return _this;
  }

  ReflectConstructAction.prototype.fetch = function fetch(session) {
    var _this2 = this;

    var target = this.fetchTarget(session);
    var argumentsList = this.argumentsList.map(function (arg) {
      return _this2.constructor.fetch(session, arg);
    });

    return Reflect.construct(target, argumentsList);
  };

  ReflectConstructAction.prototype.exec = function exec(session) {
    this.fetch(session);
  };

  ReflectConstructAction.prototype.toArgumentsList = function toArgumentsList() {
    var argumentsList = [this.target, this.argumentsList];
    var defaults = [undefined, []];

    return (0, _remoteInstance.trimArgumentsList)(argumentsList, defaults);
  };

  return ReflectConstructAction;
}(_ReflectAction3.default);

exports.default = ReflectConstructAction;