'use strict';

exports.__esModule = true;

var _remoteProtocol = require('remote-protocol');

var _ReflectAction2 = require('./ReflectAction');

var _ReflectAction3 = _interopRequireDefault(_ReflectAction2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2017 Moshe Simantov
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the Apache License, Version 2.0 (the "License");
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * you may not use this file except in compliance with the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * You may obtain a copy of the License at
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *     http://www.apache.org/licenses/LICENSE-2.0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Unless required by applicable law or agreed to in writing, software
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * distributed under the License is distributed on an "AS IS" BASIS,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * See the License for the specific language governing permissions and
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * limitations under the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var ReflectGetAction = function (_ReflectAction) {
  _inherits(ReflectGetAction, _ReflectAction);

  ReflectGetAction.fromProxy = function fromProxy(session, target, property) {
    return new this(target, session.dispatch(property));
  };

  function ReflectGetAction(target, property) {
    _classCallCheck(this, ReflectGetAction);

    if (typeof property !== 'string' && !(property instanceof _remoteProtocol.Action)) {
      throw new TypeError('Expect property to be a string or an instance of Action: ' + property);
    }

    var _this = _possibleConstructorReturn(this, _ReflectAction.call(this, target));

    _this.property = property;
    return _this;
  }

  ReflectGetAction.prototype.fetch = function fetch(session) {
    var target = this.fetchTarget(session);
    var property = this.constructor.fetch(session, this.property);

    return Reflect.get(target, property);
  };

  ReflectGetAction.prototype.exec = function exec(session) {
    this.fetch(session);
  };

  ReflectGetAction.prototype.toArgumentsList = function toArgumentsList() {
    return [this.target, this.property];
  };

  return ReflectGetAction;
}(_ReflectAction3.default);

exports.default = ReflectGetAction;