'use strict';

exports.__esModule = true;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _remoteInstance = require('remote-instance');

var _RemoteSetAction2 = require('./RemoteSetAction');

var _RemoteSetAction3 = _interopRequireDefault(_RemoteSetAction2);

var _PropertyDescriptorsAction = require('./PropertyDescriptorsAction');

var _PropertyDescriptorsAction2 = _interopRequireDefault(_PropertyDescriptorsAction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2017 Moshe Simantov
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the Apache License, Version 2.0 (the "License");
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * you may not use this file except in compliance with the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * You may obtain a copy of the License at
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *     http://www.apache.org/licenses/LICENSE-2.0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Unless required by applicable law or agreed to in writing, software
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * distributed under the License is distributed on an "AS IS" BASIS,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * See the License for the specific language governing permissions and
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * limitations under the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var ARRAY_PROTOTYPE_CODE = 1;

var RemoteSetObjectAction = function (_RemoteSetAction) {
  _inherits(RemoteSetObjectAction, _RemoteSetAction);

  RemoteSetObjectAction.fromValue = function fromValue(session, reference, obj) {
    if (obj === null) return null;

    // Fetch order should be the same: first prototype then the descriptors
    var proto = session.dispatch(this.getPrototype(obj));
    var descriptors = _PropertyDescriptorsAction2.default.fromObject(session, obj);
    var isExtensible = Object.isExtensible(obj);

    return new this(reference, descriptors.isEmpty() ? null : descriptors, proto, isExtensible);
  };

  RemoteSetObjectAction.getPrototype = function getPrototype(obj) {
    var proto = Object.getPrototypeOf(obj);

    if (proto === Object.prototype) {
      return null;
    }

    if (proto === Array.prototype) {
      return ARRAY_PROTOTYPE_CODE;
    }

    return proto;
  };

  function RemoteSetObjectAction(reference) {
    var descriptors = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var proto = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var isExtensible = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;

    _classCallCheck(this, RemoteSetObjectAction);

    if (descriptors !== null && !(descriptors instanceof _PropertyDescriptorsAction2.default)) {
      throw new TypeError('Invalid descriptors: ' + descriptors);
    }
    if ((typeof proto === 'undefined' ? 'undefined' : _typeof(proto)) !== 'object') {
      if (proto !== ARRAY_PROTOTYPE_CODE) {
        throw new TypeError('Object prototype may only be an Object or null');
      }
    }
    if (typeof isExtensible !== 'boolean') {
      throw new TypeError('Expect "isExtensible" to be boolean');
    }

    var _this = _possibleConstructorReturn(this, _RemoteSetAction.call(this, reference));

    _this.descriptors = descriptors;
    _this.proto = proto;
    _this.isExtensible = isExtensible;
    return _this;
  }

  // eslint-disable-next-line class-methods-use-this


  RemoteSetObjectAction.prototype.createInstance = function createInstance() {
    if (this.proto === ARRAY_PROTOTYPE_CODE) {
      return [];
    }

    return {};
  };

  RemoteSetObjectAction.prototype.populateInstance = function populateInstance(session, instance) {
    // Fetch order the same as dispatch order
    var proto = this.constructor.fetch(session, this.proto);
    var descriptors = this.constructor.fetch(session, this.descriptors);

    if (proto !== null && (typeof proto === 'undefined' ? 'undefined' : _typeof(proto)) === 'object') {
      Object.setPrototypeOf(instance, proto);
    }

    if (descriptors !== null) {
      Object.defineProperties(instance, descriptors);
    }
  };

  RemoteSetObjectAction.prototype.toArgumentsList = function toArgumentsList() {
    var argumentsList = [this.reference, this.descriptors, this.proto, this.isExtensible];
    var defaults = [undefined, null, null, true];

    return (0, _remoteInstance.trimArgumentsList)(argumentsList, defaults);
  };

  return RemoteSetObjectAction;
}(_RemoteSetAction3.default);

exports.default = RemoteSetObjectAction;


_RemoteSetAction3.default.types.object = RemoteSetObjectAction;