'use strict';

exports.__esModule = true;

var _remoteInstance = require('remote-instance');

var _RemoteSetAction2 = require('./RemoteSetAction');

var _RemoteSetAction3 = _interopRequireDefault(_RemoteSetAction2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2017 Moshe Simantov
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the Apache License, Version 2.0 (the "License");
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * you may not use this file except in compliance with the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * You may obtain a copy of the License at
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *     http://www.apache.org/licenses/LICENSE-2.0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Unless required by applicable law or agreed to in writing, software
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * distributed under the License is distributed on an "AS IS" BASIS,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * See the License for the specific language governing permissions and
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * limitations under the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var RemoteSetSymbolAction = function (_RemoteSetAction) {
  _inherits(RemoteSetSymbolAction, _RemoteSetAction);

  RemoteSetSymbolAction.fromValue = function fromValue(session, reference, symbol) {
    var key = Symbol.keyFor(symbol);
    if (key) return new this(reference, key, true);

    var name = symbol.toString().match(/^Symbol\((.+)\)$/);
    if (name) return new this(reference, name[1]);

    return new this(reference);
  };

  function RemoteSetSymbolAction(reference) {
    var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var isKey = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    _classCallCheck(this, RemoteSetSymbolAction);

    if (name !== null) {
      if (typeof name !== 'string') {
        throw new TypeError('Expected name to be a string or null');
      }
    } else if (isKey === true) {
      throw new TypeError('Expected name to be a valid string when Symbol has a key');
    }
    if (typeof isKey !== 'boolean') {
      throw new TypeError('Expected isKey to be boolean');
    }

    var _this = _possibleConstructorReturn(this, _RemoteSetAction.call(this, reference));

    _this.name = name;
    _this.isKey = isKey;
    return _this;
  }

  RemoteSetSymbolAction.prototype.createInstance = function createInstance() {
    if (this.isKey) {
      return Symbol.for(this.name);
    }

    return Symbol(this.name || undefined);
  };

  RemoteSetSymbolAction.prototype.toArgumentsList = function toArgumentsList() {
    var argumentsList = [this.reference, this.name, this.isKey];
    var defaults = [undefined, null, false];

    return (0, _remoteInstance.trimArgumentsList)(argumentsList, defaults);
  };

  return RemoteSetSymbolAction;
}(_RemoteSetAction3.default);

exports.default = RemoteSetSymbolAction;


_RemoteSetAction3.default.types.symbol = RemoteSetSymbolAction;